unit AMPlugIn;

interface

uses SysUtils, Classes, Windows, Graphics;

type


  PPlugIDItem = ^TPlugIDItem;
  TPlugIDItem = record
    ID,
    index : integer;
    FileSize : Cardinal;
    GroupIndex: smallint;
    HasThumb: Boolean;
  end;

  PPlugResizeParams = ^TPlugResizeParams;
   TPlugResizeParams = record
      use : boolean;
      newWidth,
      newHeight,
      ResampleFilter : integer;// 0: Nearest; 1: Linear 2: Bicubic 3: Lanczos3;
   end;

   PPlugConvertParams = ^TPlugConvertParams;
   TPlugConvertParams = record
      use : boolean;
      FileType : integer;//TIFF = 1; GIF = 2; JPEG = 3; BMP = 5; PNG = 8
      JPEG_Quality : integer;
      Interlaced : boolean;
   end;

  PExtraPlugInInfo = ^TExtraPlugInInfo;
  TExtraPlugInInfo = record
     IncludeType : integer;
     MainMenuIndex : integer;
     SubMainMenuIndex : integer;
     MenuCaption : array[0..120] of char;
     Hint : array[0..120] of char;
  end;

  THookDummy = class(TObject)
    procedure LibraryHookException(Sender: TObject; E: Exception);
  end;


  TOnSendToProgress = procedure (Sender : TObject; per : integer; Filename : string) of object;
  TGetIDList = function(_IDList : Pointer) : boolean; stdcall;
  TRegisterPI = function(PlugInHandle : DWORD) : boolean;stdcall;
  TGetThumbnailByID = function(ID : integer; tiSize : integer; Thumbnail : Pointer) : boolean; stdcall;
  TGetImagePathByID = function(ID : integer; Path : PChar; Length : integer) : boolean; stdcall;
  TCopyListToTemp = function(List : Pointer; Folder : PChar;  Width, Height, Quality : integer; Progress : Pointer; Results : Pointer) : boolean; stdcall;
  TGetImageInfoByID = function (ID : integer; PI : Pointer) : boolean; stdcall;
  TGetImageInfoByID2 = function (ID : integer; PI : Pointer; IncludeParents : boolean) : boolean; stdcall;

  TApplyQuickFilterByID = function (ID : integer; ResizeParams, ConvertParams :Pointer; DstFile : PChar) : boolean; stdcall;
  TAMHookException = procedure(Module : LongWord; Sender :Pointer; E:Pointer; Stack : Pointer);stdcall;
  TAMGetCustomInfo = function(ID : integer; ParamList : Pointer; Data : Pointer):boolean;stdcall;

  TAMResizeComressBitmap = function (Data : Pointer;
                                     Width, Height, Quality : integer;
                                     SaveRatio : boolean;
                                     Dir : PChar;
                                     NameSheet : PChar;
                                     FileName : PChar) : boolean; stdcall;


function InitializeProcs(ParentHinstance : THandle) : boolean;

var
  GetIDListProc : TGetIDList;
  GetSelItemsProc : TGetIDList;
  GetThumbnailByIDProc : TGetThumbnailByID;
  GetImagePathByIDProc : TGetImagePathByID;
  CopyListToTempProc : TCopyListToTemp;
  GetImageInfoByIDProc : TGetImageInfoByID;
  GetImageInfoByIDProc2 : TGetImageInfoByID2;
  ApplyQuickFilterProc : TApplyQuickFilterByID;
  GetCustomInfoProc : TAMGetCustomInfo;
  HookExceptionProc : TAMHookException;
  AMResizeComressBitmapProc : TAMResizeComressBitmap;
  RegisterPIProc : TRegisterPI;
  HookDummy : THookDummy;

implementation

uses
   JclHookExcept, JclDebug, Forms;


function InitializeProcs(ParentHinstance : THandle) : boolean;
begin
   Result := true;
   try
      @GetIDListProc := GetProcAddress(ParentHinstance, '_GetIDList');
      @RegisterPIProc := GetProcAddress(ParentHinstance, '_RegisterPlugIn');
      @GetSelItemsProc := GetProcAddress(ParentHinstance, '_GetSelItemsList');
      @GetThumbnailByIDProc := GetProcAddress(ParentHinstance, '_GetThumbnailByID');
      @GetImagePathByIDProc := GetProcAddress(ParentHinstance, '_GetImagePathByID');
      @CopyListToTempProc := GetProcAddress(ParentHinstance, '_CopyListToTemp');
      @GetImageInfoByIDProc := GetProcAddress(ParentHinstance, '_GetImageInfoByID');
      @GetImageInfoByIDProc2 := GetProcAddress(ParentHinstance, '_GetImageInfoByID2');      
      @ApplyQuickFilterProc := GetProcAddress(ParentHinstance, '_ApplyQuickFilter');
      @HookExceptionProc := GetProcAddress(ParentHinstance, '_HookException');
      @GetCustomInfoProc := GetProcAddress(ParentHinstance, '_GetCustomInfo');
      @AMResizeComressBitmapProc := GetProcAddress(ParentHinstance, '_ResizeCompressBitmap');
   except
      Result := false;
   end;
end;

procedure InitializeHandler;
begin
  JclStackTrackingOptions := JclStackTrackingOptions + [stRawMode];
  JclStackTrackingOptions := JclStackTrackingOptions + [stStaticModuleList];
  JclStartExceptionTracking;
end;

procedure UnInitializeHandler;
begin
  JclDebugThreadList.OnSyncException := nil;
  JclUnhookExceptions;
  JclStopExceptionTracking;
end;

{ THookDummy }

procedure THookDummy.LibraryHookException(Sender: TObject; E: Exception);
begin
    HookExceptionProc(HInstance, Sender, E, JclLastExceptStackList);
end;

initialization
// ExceptionNotify := MyNotify;

  InitializeHandler;
  HookDummy := THookDummy.Create;
  Application.OnException := HookDummy.LibraryHookException;


finalization
  UnInitializeHandler;
  Application.OnException := nil;
  HookDummy.Free;



end.
