unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ShareMem, StdCtrls, AMPlugin, Buttons, ExtCtrls, ComCtrls;

type
  PThumbInfo =^TThumbInfo;
  TThumbInfo = record
    ID : integer;
    FileFormat,
    Author,
    FileName,
    Title,
    Description,
    Keywords : string;
    Width, Height : integer;
    Colors : byte;
    FileSize : integer;//bytes
    Date : TDateTime;
    ReservedB1,
    ReservedB2,
    ReservedB3 : boolean;
    ReservedI : integer;
    ReservedS : string;
  end;

  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    bStart: TButton;
    Image1: TImage;
    bCancel: TBitBtn;
    Timer1: TTimer;
    ProgressBar1: TProgressBar;
    Memo1: TMemo;
    procedure bStartClick(Sender: TObject);
    procedure bCancelClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    MainModuleHandle : Cardinal;
    ParentHinstance : Cardinal;
    IDList : TList;
    SelItems : TList;
    CurIndex : integer;
  end;

var
  Form1: TForm1;

   function execute_plugin2(ParentHinstance : THandle;PW : THandle) : boolean; stdcall;
   procedure get_plugin_info(PlugName: PChar; PlugDesc : PChar; var PlugType : integer); stdcall;
   procedure get_plugin_info2(Info : Pointer) stdcall;

implementation
{$R *.dfm}


// Old Implementation. Use get_plugin_info2 instead
procedure get_plugin_info(PlugName: PChar; PlugDesc : PChar; var PlugType : integer); stdcall;
var S : string;
    i : integer;
begin
  S := 'Demo Plugin';
  for i := 0 to length(s) do
      PlugName[i] := S[i+1];
  PlugType := 1;// PlugType=1 -> Registered in the "Send To" menu
end;


procedure get_plugin_info2(Info : Pointer) stdcall;
var S : string;
    i : integer;
begin
   PExtraPlugInInfo(Info)^.IncludeType := 1;
   PExtraPlugInInfo(Info)^.MainMenuIndex := -1;
   PExtraPlugInInfo(Info)^.SubMainMenuIndex := -1;
   S := 'Demo Plugin Button Hint';
   for i := 1 to length(s) do
        PExtraPlugInInfo(Info)^.Hint[i-1] := S[i];
   S := 'Do something with this Demo Plugin';     
   for i := 1 to length(s) do
        PExtraPlugInInfo(Info)^.MenuCaption[i-1] := S[i];
end;


function execute_plugin2(ParentHinstance : THandle;PW : THandle) : boolean; stdcall;
var
  CanContinue : boolean;
  Icon : TIcon;
begin
   CanContinue := True;

   Application.CreateForm(TForm1, Form1);
   Application.Handle := Form1.Handle;
   Form1.ParentHinstance := ParentHinstance;
   Form1.MainModuleHandle := PW;

    Form1.Icon.Handle := LoadIcon(HInstance,'MAINICON');

   if ParentHinstance <> 0 then begin
      Form1.IDList := TList.Create;
      Form1.SelItems := TList.Create;
      InitializeProcs(ParentHinstance);

      if (@ApplyQuickFilterProc = nil) or
         (@GetImageInfoByIDProc = nil) or
//         (@CopyListToTempProc = nil) or
         (@GetImagePathByIDProc = nil) or
         (@GetIDListProc = nil) or
         (@GetSelItemsProc = nil) or
         (@GetThumbnailByIDProc = nil) then
      begin
          ShowMessage('Unable to connect to a main program');
          CanContinue := False;
       end
       else
       begin
          if not GetIDListProc(Form1.IDList) then
          begin
              CanContinue := False;
              ShowMessage('Unable to get IDList');
          end;

          if CanContinue then
          begin
             if not GetSelItemsProc(Form1.SelItems) then
             begin
                CanContinue := False;
                ShowMessage('Unable to get SelItems');
             end;
          end;
       end;

       if CanContinue then
       begin
          Form1.Edit1.Text := IntToStr(Form1.SelItems.Count);
          Form1.ShowModal;
       end;

    end
    else
      ShowMessage('Unable to connect to main program');

    FreeAndNil(Form1);
    Result := True;

end;


procedure TForm1.bStartClick(Sender: TObject);
begin
  ProgressBar1.Max := SelItems.Count;
  ProgressBar1.Position := 0;
  CurIndex := 0;
  bStart.Enabled := false;
  bCancel.Enabled := true;
  Timer1.Enabled := true;
end;

procedure TForm1.bCancelClick(Sender: TObject);
begin
  bStart.Enabled := true;
  bCancel.Enabled := false;
  Timer1.Enabled := false;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
   ItemID : integer;
   PI : TThumbInfo;
begin
   inc(CurIndex);
   ProgressBar1.Position := CurIndex;

   if CurIndex > SelItems.Count - 1 then
   begin
     Timer1.Enabled := false;
     Exit;
   end;

   Memo1.Lines.Clear;
   ItemID := PPlugIDItem(SelItems[CurIndex]).ID;

   // size = 64, 128, 256
   GetThumbnailByIDProc(ItemID, 128, Image1.Picture.Bitmap);

   if Assigned(GetImageInfoByIDProc2)  then
      GetImageInfoByIDProc2(ItemID, @PI, true) else
      GetImageInfoByIDProc(ItemID, @PI);

    Memo1.Lines.Add('Filename: ' + PI.FileName);
//    Memo1.Lines.Add('Author: ' + PI.Author);
    Memo1.Lines.Add('Title: ' + PI.Title);
    Memo1.Lines.Add('Keywords: ' + PI.Keywords);
    Memo1.Lines.Add('FileFormat: ' + PI.FileFormat);        

end;

procedure TForm1.FormShow(Sender: TObject);
begin
   bStart.Enabled := SelItems.Count > 0; 
end;

end.

